/*******************************************************************************

Program:

	Basic.h
	01.01.00

Title:

	Basic Translater Main Header File

Description:

	This is the main header file for the basic translater.

Bugs:

History:

	01.01.01 - 10/22/1996 - Kevin Handy
		Added variables 'IntegerType' and 'RealType'.

*******************************************************************************/
#ifndef _BASIC_H_
#define _BASIC_H_
#ifndef TRUE
#define TRUE 1
#define FALSE 0
#endif

//
// Include files
//
#include <fstream.h>
#include "nodes.h"
#include "variable.h"

//
// Format for transfering info between flex and yacc
//
#define YYSTYPE Node *

//
// Required by Lex and Yacc
//
extern FILE *yyin;
extern int xline;
extern int yydebug;

//
// External stuff in basic_main.c
//
extern VariableList *Variables;

extern int CompileFlag;

extern int NeedIostreamH;
extern int NeedStdlibH;
extern int NeedStringH;
extern int NeedMathH;
extern int NeedErrorH;
extern int NeedRFA;
extern int NeedBasicFun;
extern int NeedTimeH;
extern int NeedDataList;

extern int IntegerType;
extern int RealType;

extern int DebugDump;
extern int DebugDumpOne;
extern int VariableDump;
extern int PositionDump;

void DoProgram(Node *Program);

#ifndef __MSDOS__
char *strupr(char *s);
char *strlwr(char *s);
#endif

//
// Parsing stuff
//
extern int xline;
extern int include_stack_pointer;
extern Node* CommentList;
extern char* include_name[];

int yyparse();
int yyerror(char *s);
int yylex( void );

#ifdef __MSDOS__
extern "C"
{
	void* alloca(int);
}
#endif

#endif
