//
// Header file for special routines written to handle basic
// functions that do not have a direct C++ equivelent.
//
// History:
//
//	01.01.01 - 09/20/1996 - Kevin Handy
//		Put '#ifdef' around entire include file.
//
#ifndef _BASICFUN_H_
#define _BASICFUN_H_

//
// Instr search function.
//
inline int instr(int Start, char* Base, char* Search)
{
	char* test = strstr((Base + Start - 1), Search);
	return (test != NULL) ? (int)(test - Base + 1) : 0;
}

//
// Rnd (random number between 0 and 1)
//	This is a real nasty hack, and may not produce as
//	wide a range of random numbers as basic desires.
//
inline double floatrand()
{
	return ((double) rand()) / ((double) RAND_MAX);
}

//
// BasicChannel class (I/O functions)
//
//	Note: Only have basic layout defined.
//	Functions are not cefined anywhere yet.
//
class BasicChannel
{
public:
	BasicChannel();
	~BasicChannel();

	void Open(char* FileName);
	void Close();
	void Reset();
	void Put();
	void Get();
	void Delete();
	void Find();
	void Unlock();
	void SetRecordSize();
	void SetFileSize();
	void SetExtendSize();
	void SetWindowSize();
	void etBlockSize();
	void SetBucketSize();
	void SetMode();
	void SetBuffer();
	void SetDefaultName();
	void SetKey();
	void SetTemporary();
	void SetContiguous();
	void SetRewind();
	void SetSpan();
	void SetOrginization();
	void SetAccess();
	void SetAllow();
	void SetConnect();
	void SetMap();
	void SetRecordType();
	void GoofyOpenStuff();
};

#endif
