//
// Nodes.h
//
#ifndef _NODES_H_
#define _NODES_H_

#include <iostream.h>

//
// Forward definitions
//
class VariableStruct;

//
// Main structure defining the program
//
class Node
{
private:
	int Type;		// Node Type
	char *TextValue;	// Text value associated with node
	Node *Down;		// Down pointer
	Node *Tree[4];		// Pointers to other nodes
	static int Level;	// Indentation level
	int FromInclude;	// Is this from an include file?

public:
	Node(int TypeValue = 0, char *TextValue = NULL, int Include = 0);
	~Node();

	Node* GetDown() { return Down; }
	int GetType() { return Type; }
	char* GetText() { return TextValue; }
	Node* GetTree(int Ptr) { return Tree[Ptr]; }
	Node& NoParen();

	void SetType(int NewType) { Type = NewType; }
	void SetInclude(int NewValue) { FromInclude = NewValue; }

	Node *Link(
		struct Node *Node0 = NULL, struct Node *Node1 = NULL,
		struct Node *Node2 = NULL, struct Node *Node3 = NULL);
				// Attach parameter nodes to main node
	Node *DownLink(struct Node *Node0);
				// Attach links at same level
	void UnDownLink() { Down = NULL; }

	void PrintTree(char* Level = "", int flag = 0, char Node = '*');
	void VariableScan(int AFlag);
	void VariableScanOne(int AFlag);
	int ScanType();
	void Output(ostream& os);
	void OutputCode(ostream& os);
	void OutputCodeOne(ostream& os);

	friend ostream& operator<< (ostream& os, Node& nn)
		{ nn.OutputCodeOne(os); return os; }
	friend ostream& operator<< (ostream& os, Node* nn)
		{ nn->OutputCodeOne(os); return os; }

private:
	void OutputBlock(ostream& os);
	void OutputPrint(ostream& os);
	void OutputInput(ostream& os);
	int OutputIPData(ostream& os, int InputFlag);
	void OutputData(ostream& os);
	void OutputDataValue(ostream& os);
	void OutputMap(ostream& os);
	void OutputOneMap(ostream& os, VariableStruct* MapVar);
	void ScanMap();
	void ScanOneMap(VariableStruct* MapVar);
	void OutputCaseLabel(ostream& os);
	void OutputVarName(ostream& os);
	void Indent(ostream& os);
	void ScanVarList(int ThisType, int ThisClass, int Status);
	void OutputRemark(ostream& os);
	void OutputDatatype(ostream& os, int ThisType);
	void OutputLabel(ostream& os);
	void OutputOngo(ostream& os, const char* GoType, int GoLevel);
	void OutputDefinition(ostream& os, Node* MainType, int ExtType);
	void OutputRecord(ostream& os);
	void OutputArrayParam(ostream& os);
	void OutputOpenStuff(ostream& os, Node* Channel);
	void OutputBstringText(ostream& os);
};

Node* ScanForLoops(Node* Program);

#endif
