/* Parse.y
 *
 * History:
 *
 *	01.01.00 - 08/30/1996 - Kevin Handy
 *		Set version number to 1.1, and install on internet.
 *
 *	01.01.01 - 09/04/1996 - Kevin Handy
 *		Added "BLOCK" for get clause.
 *
 *	01.01.02 - 09/26/1996 - Kevin Handy
 *		Lose two 'bstruct' and 'tempch' variables that were
 *		defined but never used, and two debug macros that
 *		are no longer used.
 *
 *	01.01.03 - 10/09/1996 - Kevin Handy
 *		Added BAS_V_PREDEF constants.
 *
 *	01.01.04 - 10/22/1996 - Kevin Handy
 *		Handle new variables 'IntegerType' and 'RealType',
 *		as well as new variable types 'SINGLE', 'GFLOAT',
 *		and 'HFLOAT'.
 *
 *	01.01.05 - 11/12/1996 - Kevin Handy
 *		Have "close" generate a 'downlink' of closes instead
 *		of a close linked to a list, so can lose function from
 *		nodes.cc.
 *		Same for "read".
 *
 *	01.02.01 - 11/12/1996 - Kevin Handy
 *		"forassignment" shouldn't allow a list for the lvalue.
 */

%{
#include <stdio.h>
#include "basic.h"
#include "nodes.h"

#ifndef YYSTYPE
#define YYSTYPE Node *
#endif

#ifndef YYDEBUG
#define YYDEBUG 0
#endif
%}

%start program

%token BAS_S_ACCESS
%token BAS_S_ACTIVE
%token BAS_S_ALLOW
%token BAS_S_ALTERNATE
%token BAS_S_ANY
%token BAS_S_APPEND
%token BAS_S_AS
%token BAS_S_BACK
%token BAS_S_BLOCK
%token BAS_S_BLOCKSIZE
%token BAS_S_BUCKETSIZE
%token BAS_S_BUFFER
%token BAS_S_BY
%token BAS_S_BYTE
%token BAS_S_CALL
%token BAS_S_CASE
%token BAS_S_CHAIN
%token BAS_S_CHANGE
%token BAS_S_CHANGES
%token BAS_S_CLOSE
%token BAS_S_COMMON
%token BAS_S_CONSTANT
%token BAS_S_CONTIGUOUS
%token BAS_S_CONNECT
%token BAS_S_COUNT
%token BAS_S_DATA
%token BAS_S_DECIMAL
%token BAS_S_DECLARE
%token BAS_S_DEF
%token BAS_S_DEFAULTNAME
%token BAS_S_DELETE
%token BAS_S_DESC
%token BAS_S_DIM
%token BAS_S_DOUBLE
%token BAS_S_DUPLICATES
%token BAS_S_ELSE
%token BAS_S_END
%token BAS_S_EQ
%token BAS_S_ERL
%token BAS_S_ERR
%token BAS_S_ERROR
%token BAS_S_EXIT
%token BAS_S_EXPLICIT
%token BAS_S_EXTEND
%token BAS_S_EXTENDSIZE
%token BAS_S_EXTERNAL
%token BAS_S_FIELD
%token BAS_S_FILE
%token BAS_S_FILL
%token BAS_S_FILESIZE
%token BAS_S_FIND
%token BAS_S_FIXED
%token BAS_S_FNEND
%token BAS_S_FNEXIT
%token BAS_S_FOR
%token BAS_S_FORTRAN
%token BAS_S_FREE
%token BAS_S_FROM
%token BAS_S_FUNCTION
%token BAS_S_FUNCTIONEND
%token BAS_S_FUNCTIONEXIT
%token BAS_S_GE
%token BAS_S_GET
%token BAS_S_GFLOAT
%token BAS_S_GO
%token BAS_S_GOSUB
%token BAS_S_GOTO
%token BAS_S_GT
%token BAS_S_HFLOAT
%token BAS_S_IF
%token BAS_S_INACTIVE
%token BAS_S_INDEXED
%token BAS_S_INPUT
%token BAS_S_INTEGER
%token BAS_S_ITERATE
%token BAS_S_KEY
%token BAS_S_KILL
%token BAS_S_LET
%token BAS_S_LINE
%token BAS_S_LINPUT
%token BAS_S_LIST
%token BAS_S_LONG
%token BAS_S_LSET
%token BAS_S_MAP
%token BAS_S_MARGIN
%token BAS_S_MODE
%token BAS_S_MODIFY
%token BAS_S_MOVE
%token BAS_S_NAME
%token BAS_S_NEXT
%token BAS_S_NOCHANGES
%token BAS_S_NODUPLICATES
%token BAS_S_NONE
%token BAS_S_NOREWIND
%token BAS_S_NOSPAN
%token BAS_S_ON
%token BAS_S_OPEN
%token BAS_S_OPTION
%token BAS_S_ORGANIZATION
%token BAS_S_OTHERWISE
%token BAS_S_OUTPUT
%token BAS_S_OVERFLOW
%token BAS_S_PRIMARY
%token BAS_S_PRINT
%token BAS_S_PUT
%token BAS_S_RANDOM
%token BAS_S_READ
%token BAS_S_REAL
%token BAS_S_RECORD
%token BAS_S_RECORDTYPE
%token BAS_S_RECORDSIZE
%token BAS_S_REF
%token BAS_S_REGARDLESS
%token BAS_S_RELATIVE
%token BAS_S_REMAP
%token BAS_S_REMARK
%token BAS_S_REMARKLINE
%token BAS_S_RESTORE
%token BAS_S_RESET
%token BAS_S_RESUME
%token BAS_S_RETURN
%token BAS_S_REWIND
%token BAS_S_RFA
%token BAS_S_ROUNDING
%token BAS_S_RSET
%token BAS_S_SCRATCH
%token BAS_S_SELECT
%token BAS_S_SEQUENTIAL
%token BAS_S_SINGLE
%token BAS_S_SIZE
%token BAS_S_SLEEP
%token BAS_S_SPAN
%token BAS_S_STEP
%token BAS_S_STOP
%token BAS_S_STREAM
%token BAS_S_STRING
%token BAS_S_SUB
%token BAS_S_SUBEND
%token BAS_S_SUBEXIT
%token BAS_S_SUBSCRIPT
%token BAS_S_TEMPORARY
%token BAS_S_THEN
%token BAS_S_TO
%token BAS_S_TYPE
%token BAS_S_UNDEFINED
%token BAS_S_UNLESS
%token BAS_S_UNLOCK
%token BAS_S_UNTIL
%token BAS_S_UPDATE
%token BAS_S_USEROPEN
%token BAS_S_USING
%token BAS_S_VALUE
%token BAS_S_VARIABLE
%token BAS_S_VARIANT
%token BAS_S_VIRTUAL
%token BAS_S_WAIT
%token BAS_S_WHILE
%token BAS_S_WINDOWSIZE
%token BAS_S_WORD
%token BAS_S_WRITE

%token BAS_P_INCLUDE
%token BAS_P_FROM
%token BAS_P_CDD
%token BAS_P_TITLE
%token BAS_P_SBTTL
%token BAS_P_IDENT

%token BAS_V_FUNCTION
%token BAS_V_FLOAT
%token BAS_V_INTEGER
%token BAS_V_INT
%token BAS_V_LABEL
%token BAS_V_USELABEL
%token BAS_V_NAME
%token BAS_V_TEXTSTRING
%token BAS_V_RMSRECORD
%token BAS_V_PREDEF

%token BAS_X_UNARYLT
%token BAS_X_UNARYLE
%token BAS_X_UNARYGT
%token BAS_X_UNARYGE
%token BAS_X_UNARYNEQ

%left BAS_X_STRREF

%left BAS_X_NEQ BAS_X_GE BAS_X_LE BAS_S_EQV
%left BAS_S_NOT
%left '+' '-'
%left '*' '/'
%right '^'
%left '=' '>' '<'
%left BAS_S_AND BAS_S_OR BAS_S_IMP BAS_S_XOR
%nonassoc UMINUS
%left ','

%token BAS_N_UMINUS
%token BAS_N_UPLUS
%token BAS_N_ASSIGN
%token BAS_N_FORASSIGN
%token BAS_N_ASSIGNLIST
%token BAS_N_LIST
%token BAS_N_ENDIF
%token BAS_N_ONGOTO
%token BAS_N_ONGOSUB
%token BAS_N_ONERROR
%token BAS_N_ENDSELECT
%token BAS_N_ENDRECORD
%token BAS_N_EXTERNALFUNCTION
%token BAS_N_EXTERNALSUB
%token BAS_N_EXTERNALCONSTANT
%token BAS_N_FORUNTIL
%token BAS_N_FORWHILE
%token BAS_N_CASEELSE
%token BAS_N_NULL
%token BAS_N_VARTYPE
%token BAS_N_ENDVARIANT
%token BAS_N_RECORD
%token BAS_N_STRUCTNAME
%token BAS_N_TYPEFUN

%%
 /* Grammer rules */
program:	doprogram { DoProgram($1); }
;

doprogram:	/* Empty */ { $$ = NULL; }
		| nline doprogram { $$ = $1->DownLink($2); }
;

nline:		linenum label statement '\n' { $$ =
			CommentList->DownLink($1->DownLink($2->DownLink($3)));
			CommentList = NULL; }
;

linenum:	/* Empty */ {$$ = NULL;}
		| BAS_V_INTEGER { $1->SetType(BAS_V_LABEL); $$ = $1; }
;

label:		/* Empty */ {$$ = NULL;}
		| BAS_V_LABEL
;

statement:	statementx
		| statement '\\' statementx { delete $2;
			$$ = $1->DownLink($3); }
		| statement BAS_S_THEN statementw {
			$$ = $1->DownLink($2->DownLink($3)); }
		| statement BAS_S_ELSE statementw {
			$$ = $1->DownLink($2->DownLink($3)); }
		| statement BAS_N_ENDIF statementx {
			$$ = $1->DownLink($2->DownLink($3)); }
;

statementw:	statementx
		| BAS_V_INTEGER { $$ = (new Node(BAS_S_GOTO,
		"", 0))->Link($1); } /* For 'THEN 1000' */

statementx:	/* Empty */ {$$ = NULL;}
		| stmtnomod
		| stmtmodlist
;

stmtmodlist:	stmtmod
		| stmtmodlist ifmod { $$ = $2->Link(NULL, NULL, NULL, $1); }
		| stmtmodlist unlessmod { $$ = $2->Link(NULL, NULL, NULL, $1); }
		| stmtmodlist formod { $$ = $2->Link(NULL, NULL, NULL, $1); }
		| stmtmodlist whilemod { $$ = $2->Link(NULL, NULL, NULL, $1); }
		| stmtmodlist untilmod { $$ = $2->Link(NULL, NULL, NULL, $1); }
;

ifmod:		BAS_S_IF expression  { $$ = $1->Link($2); }
;

unlessmod:	BAS_S_UNLESS expression  { $$ = $1->Link($2); }
;

whilemod:	BAS_S_WHILE expression  { $$ = $1->Link($2); }
;

untilmod:	BAS_S_UNTIL expression  { $$ = $1->Link($2); }
;

formod:		BAS_S_FOR forassignment BAS_S_TO expression { delete $3;
			$$ = $1->Link($2, $4); }
		| BAS_S_FOR forassignment BAS_S_TO expression BAS_S_STEP expression {delete $3;
			delete $5;
			$$ = $1->Link($2, $4, $6); }
		| BAS_S_FOR forassignment BAS_S_UNTIL expression { delete $3;
			$1->SetType(BAS_N_FORUNTIL);
			$$ = $1->Link($2, $4); }
		| BAS_S_FOR forassignment BAS_S_WHILE expression { delete $3;
			$1->SetType(BAS_N_FORWHILE);
			$$ = $1->Link($2, $4); }
;

stmtmod:	assignment
		| BAS_S_CALL variable { $2->SetType(BAS_V_FUNCTION);
			$$ = $1->Link($2); }
		| BAS_S_CHAIN expression {$$ = $1->Link($2); }
		| BAS_S_CHAIN expression BAS_S_LINE expression {
			$$ = $1->Link($2, $4); delete $3; }
		| BAS_S_CHANGE expression BAS_S_TO expression {
			$$ = $1->Link($2, $4); delete $3; }
		| BAS_S_CLOSE '#' closelist {$$ = $3;
			delete $1; delete $2; }
		| BAS_S_CLOSE closelist {$$ = $2; delete $1; }
		| BAS_S_DELETE '#' expression { $$ = $1->Link($3); delete $2; }
		| BAS_S_EXIT BAS_S_FUNCTION { $1->SetType(BAS_S_FUNCTIONEXIT);
			$$ = $1; delete $2; }
		| BAS_S_EXIT BAS_S_SUB { $1->SetType(BAS_S_SUBEXIT);
			$$ = $1; delete $2; }
		| BAS_S_EXIT lineno {$1->SetType(BAS_S_GOTO); $$ = $1->Link($2); }
		| BAS_S_FIELD '#' expression ',' fieldlist {
			$$ = $1->Link($3, $5); delete $2; delete $4; }
		| BAS_S_FIND '#' expression getclause { $$ = $1->Link($3, $4);
			delete $2; }
		| BAS_S_FOR forassignment BAS_S_TO expression { delete $3;
			$$ = $1->Link($2, $4); }
		| BAS_S_FOR forassignment BAS_S_TO expression BAS_S_STEP expression { delete $3;
			delete $5; $$ = $1->Link($2, $4, $6); }
		| BAS_S_FOR forassignment BAS_S_UNTIL expression { delete $3;
			$1->SetType(BAS_N_FORUNTIL);
			$$ = $1->Link($2, $4); }
		| BAS_S_FOR forassignment BAS_S_WHILE expression { delete $3;
			$1->SetType(BAS_N_FORWHILE);
			$$ = $1->Link($2, $4); }
		| BAS_S_FNEXIT
		| BAS_S_FREE '#' expression  { $$ = $1->Link($3);
			delete $2; }
		| BAS_S_FUNCTIONEXIT { $1->SetType(BAS_S_FNEXIT); $$ = $1; }
		| BAS_S_GET '#' expression getclause { $$ = $1->Link($3, $4);
			delete $2; }
		| BAS_S_GOSUB lineno {$$ = $1->Link($2); }
		| BAS_S_GOTO lineno {$$ = $1->Link($2); }
		| BAS_S_GO BAS_S_SUB lineno { $1->SetType(BAS_S_GOSUB);
			$$ = $1->Link($3); delete $2; }
		| BAS_S_GO BAS_S_TO lineno { $1->SetType(BAS_S_GOTO);
			$$ = $1->Link($3); delete $2; }
		| BAS_S_INPUT optinput {
			$$ = $1->Link($2); NeedIostreamH = 1; }
		| BAS_S_INPUT BAS_S_LINE optinput { $1->SetType(BAS_S_LINPUT);
			$$ = $1->Link($3);
			delete $2; NeedIostreamH = 1; }
		| BAS_S_ITERATE
		| BAS_S_ITERATE lineno { $1->SetType(BAS_S_GOTO);
			$$ = $1->Link($2); }
		| BAS_S_KILL expression {$$ = $1->Link($2); }
		| BAS_S_LET assignment {$$ = $2; delete $1; }
		| BAS_S_LINPUT optinput {
			$$ = $1->Link($2); NeedIostreamH = 1; }
		| BAS_S_LSET assignment {$$ = $1->Link($2); }
		| BAS_S_MARGIN '#' expression ',' expression {
			$$ = $1->Link($3, $5); delete $2; delete $4; }
		| BAS_S_MOVE BAS_S_TO '#' expression ',' expression {
			$$ = $1->Link($4, $6); delete $2; delete $3;
			delete $5; }
		| BAS_S_MOVE BAS_S_FROM '#' expression ',' expression {
			$$ = $1->Link($4, $6); delete $2; delete $3;
			delete $5; }
		| BAS_S_NAME expression BAS_S_AS expression { delete $3;
			$$ = $1->Link($2, $4); }
		| BAS_S_NEXT
		| BAS_S_NEXT variable { $$ = $1->Link($2); }
		| BAS_S_ON BAS_S_ERROR BAS_S_GO BAS_S_TO lineno { $1->SetType(BAS_N_ONERROR);
			$$ = $1->Link($5); delete $2;
			delete $3; delete $4; }
		| BAS_S_ON BAS_S_ERROR BAS_S_GOTO lineno { $1->SetType(BAS_N_ONERROR);
			$$ = $1->Link($4); delete $2; delete $3; }
		| BAS_S_ON BAS_S_ERROR BAS_S_GO BAS_S_BACK { $1->SetType(BAS_N_ONERROR);
			$$ = $1->Link($4); delete $2; delete $3; }
		| BAS_S_ON expression BAS_S_GOTO linelist { $1->SetType(BAS_N_ONGOTO);
			$$ = $1->Link($2, $4); delete $3; }
		| BAS_S_ON expression BAS_S_GO BAS_S_TO linelist { $1->SetType(BAS_N_ONGOTO);
			$$ = $1->Link($2, $5); delete $3; delete $4; }
		| BAS_S_ON expression BAS_S_GOSUB linelist { $1->SetType(BAS_N_ONGOSUB);
			$$ = $1->Link($2, $4); delete $3; }
		| BAS_S_ON expression BAS_S_GO BAS_S_SUB linelist { $1->SetType(BAS_N_ONGOSUB);
			$$ = $1->Link($2, $5); delete $3; delete $4; }
		| BAS_S_OPEN expression optfor BAS_S_AS BAS_S_FILE chexpression openlist {
			$$ = $1->Link($2, $3, $6, $7);
			delete $4; delete $5; }
		| BAS_S_PRINT optprint { $$ = $1->Link($2); NeedIostreamH = 1; }
		| BAS_S_PUT '#' expression getclause { $$ = $1->Link($3, $4);
			delete $2; }
		| BAS_S_RANDOM
		| BAS_S_READ readlist { $$ = $2; delete $1 }
		| BAS_S_RESET { $$ = $1; NeedDataList = 1; }
		| BAS_S_RESET '#' expression getclause { $$ = $1->Link($3, $4);
			delete $2; }
		| BAS_S_RESTORE { $$ = $1; NeedDataList = 1; }
		| BAS_S_RESTORE '#' expression getclause { $$ = $1->Link($3, $4);
			delete $2; }
		| BAS_S_RESUME
		| BAS_S_RESUME lineno { $$ = $1->Link($2); }
		| BAS_S_RETURN
		| BAS_S_RSET assignment { $$ = $1->Link($2); }
		| BAS_S_SLEEP expression { $$ = $1->Link($2); }
		| BAS_S_STOP
		| BAS_S_SUBEXIT
		| BAS_S_UNLOCK '#' expression { $$ = $1->Link($3);
			delete $2; }
		| BAS_S_UNTIL expression { $$ = $1->Link($2); }
		| BAS_S_UPDATE '#' expression { $$ = $1->Link($3);
			delete $2; }
		| BAS_S_WAIT expression { $$ = $1->Link($2); }
		| BAS_S_WHILE expression { $$ = $1->Link($2); }
;

stmtnomod:	BAS_S_CASE caseexprlist { $$ = $1->Link($2); }
		| BAS_N_CASEELSE
		| BAS_S_COMMON '(' BAS_V_NAME ')' funparlist { delete $2;
			delete $4; $$ = $1->Link($3, $5); }
		| BAS_S_DATA datalist { NeedDataList = 1; $$ = $1->Link($2); }
		| BAS_S_DECLARE declarelist { $$ = $1->Link(NULL, NULL, $2); }
		| BAS_S_DECLARE vartype BAS_S_CONSTANT assignlist {
			$$ = $1->Link($3, $2, $4); }
		| BAS_S_DECLARE vartype BAS_S_FUNCTION fundeflist {
			$$ = $1->Link($3, $2, $4); }
		| BAS_S_DEF optvartype fundef funequ {
			$$ = $1->Link($2, NULL, $3, $4); }
		| BAS_S_DEF '*' optvartype fundef funequ {
			$$ = $1->Link($3, NULL, $4, $5); delete $2; }
		| BAS_S_DIM opchan dimdeflist { $$ = $1->Link($3, $2); }
		| BAS_S_END BAS_S_FUNCTION { $1->SetType(BAS_S_FUNCTIONEND);
			$$ = $1; delete $2; }
		| BAS_S_END BAS_S_SELECT { $1->SetType(BAS_N_ENDSELECT);
			delete $2; $$ = $1; }
		| BAS_S_END BAS_S_SUB { $1->SetType(BAS_S_SUBEND);
			delete $2; }
		| BAS_S_END BAS_S_DEF { $1->SetType(BAS_S_FNEND);
			delete $2; }
		| BAS_S_END BAS_S_RECORD {$1->SetType(BAS_N_ENDRECORD);
			delete $2; $$ = $1; }
		| BAS_S_END BAS_S_RECORD BAS_V_NAME {$1->SetType(BAS_N_ENDRECORD);
			delete $2; $$ = $1; delete $3; }
		| BAS_S_END
		| BAS_S_EXTEND { delete $1; $$ = NULL; }
		| BAS_S_EXTERNAL vartype BAS_S_FUNCTION fundeflist {
			$1->SetType(BAS_N_EXTERNALFUNCTION);
			delete $3;
			$$ = $1->Link(NULL, $2, $4); }
		| BAS_S_EXTERNAL vartype BAS_S_CONSTANT variablelist {
			$1->SetType(BAS_N_EXTERNALCONSTANT);
			delete $3;
			$$ = $1->Link(NULL, $2, $4); }
		| BAS_S_EXTERNAL BAS_S_SUB fundeflist {
			$1->SetType(BAS_N_EXTERNALSUB);
			delete $2; $$ = $1->Link(NULL, $3); }
		| BAS_S_EXTERNAL vartype variablelist {
			$$ = $1->Link(NULL, $2, $3); }
		| BAS_S_FNEND
		| BAS_S_FUNCTION vartype fundef { $$ = $1->Link($2, NULL, $3); }
		| BAS_S_FUNCTIONEND
		| BAS_S_IF expression { $$ = $1->Link($2); }
		| BAS_S_MAP '(' BAS_V_NAME ')' maplist { delete $2;
			delete $4; $$ = $1->Link($3, $5); }
		| BAS_S_OPTION BAS_S_SIZE '=' optiontype { $$ = NULL; delete $1;
			delete $2; delete $3; }
		| BAS_S_SELECT expression { $$ = $1->Link($2); }
		| BAS_S_SUB fundef { $$ = $1->Link(NULL, NULL, $2); }
		| BAS_S_SUBEND
		| BAS_P_INCLUDE BAS_V_TEXTSTRING { $$ = $1->Link($2); }
		| BAS_P_INCLUDE BAS_P_FROM BAS_P_CDD BAS_V_TEXTSTRING { delete $1;
			delete $2; $$ = $3->Link($4); }
		| BAS_S_RECORD BAS_V_NAME { $1->Link($2); }
		| BAS_P_TITLE BAS_V_TEXTSTRING { $$ = $1->Link($2); }
		| BAS_P_SBTTL BAS_V_TEXTSTRING { $$ = $1->Link($2); }
		| BAS_P_IDENT BAS_V_TEXTSTRING { $$ = $1->Link($2); }
		| BAS_S_VARIANT
		| BAS_S_END BAS_S_VARIANT { $2->SetType(BAS_N_ENDVARIANT);
			delete $1; $$ = $2; }
		| vardef
;

opchan:		/* Empty */ { $$ = NULL; }
		| '#' expression ',' { $$ = $2; delete $1; delete $3; }
;

vardef:		vartype variablex morevartype { 
			$$ = ($1->Link(NULL, NULL, $2))->DownLink($3); }
		| BAS_V_NAME variablex morevartype { $1->SetType(BAS_N_VARTYPE);
			$$ = ($1->Link(NULL, NULL, $2))->DownLink($3); }
		| vartype variablex '=' expression morevartype {
			$$ = $1->DownLink($2->Link(NULL, NULL, $4))->
			DownLink($5);
			delete $3; }
		| BAS_V_NAME variablex '=' expression morevartype {
			$1->SetType(BAS_N_VARTYPE);
			$$ = $1->Link(NULL, NULL, $2->Link(NULL, NULL, $4))->DownLink($5);
			delete $3; }
		| BAS_S_FILL morevartype { $$ = $1->DownLink($2); }
		| vartype BAS_S_FILL morevartype {
			$$ = ($1->Link(NULL, NULL, $2))->DownLink($3); }
		| vartype BAS_S_FILL '=' expression morevartype {
			$$ = ($1->Link(NULL, NULL, $2->Link(NULL, NULL,
			$4)))->DownLink($5); delete $3; }
		| BAS_S_FILL '=' expression morevartype {
			$$ = ($1->Link(NULL, NULL, $3))->DownLink($4); delete $2; }
;

morevartype:	/* Empty */ { $$ = NULL; }
		| ',' vardef { delete $1; $$ = $2; }
;

assignlist:	assignment
		| assignment ',' assignlist { $2->SetType(BAS_N_LIST);
			$$ = $2->Link($1, $3); }
;

assignment:	aslist '=' expression { $2->SetType(BAS_N_ASSIGN);
			$$ = $2->Link($1, $3); }
;

aslist:		variable ',' aslist { $2->SetType(BAS_N_ASSIGNLIST);
			$$ = $2->Link($1, $3); }
		| variable
;


forassignment:	variable '=' expression { $2->SetType(BAS_N_FORASSIGN);
			$$ = $2->Link($1, $3); }
;

chexpression:	expression
		| '#' expression { $$ = $2; delete $1; }
;

expression:	variable
		| constant
		| function
		| BAS_V_PREDEF
		| BAS_S_ERR
		| BAS_S_ERL
		| expression BAS_S_EQV expression  { $$ = $2->Link($1, $3); }
		| expression BAS_S_IMP expression  { $$ = $2->Link($1, $3); }
		| expression BAS_S_OR expression  { $$ = $2->Link($1, $3); }
		| expression BAS_S_XOR expression  { $$ = $2->Link($1, $3); }
		| expression BAS_S_AND expression   { $$ = $2->Link($1, $3); }
		| BAS_S_NOT expression %prec UMINUS { $$ = $1->Link($2); }
		| expression '>' expression  { $$ = $2->Link($1, $3); }
		| expression '<' expression  { $$ = $2->Link($1, $3); }
		| expression '=' expression  { $$ = $2->Link($1, $3); }
		| expression BAS_X_NEQ expression  { $$ = $2->Link($1, $3); }
		| expression BAS_X_GE expression  { $$ = $2->Link($1, $3); }
		| expression BAS_X_LE expression  { $$ = $2->Link($1, $3); }
		| expression '+' expression  { $$ = $2->Link($1, $3); }
		| expression '-' expression  { $$ = $2->Link($1, $3); }
		| expression '*' expression  { $$ = $2->Link($1, $3); }
		| expression '/' expression  { $$ = $2->Link($1, $3); }
		| expression '^' expression  { $$ = $2->Link($1, $3); }
		| '-' expression %prec UMINUS { $1->SetType(BAS_N_UMINUS);
			$$ = $1->Link($2); }
		| '+' expression %prec UMINUS { $1->SetType(BAS_N_UPLUS);
			$$ = $1->Link($2); }
		| '(' expression ')' { delete $3; $$ = $1->Link($2); }
;

prenexprlist:	variable
		| '(' exprlist ')' {$$ = $2; delete $1; delete $3; }
;

exprlist:	/* Empty */ { $$ = NULL; }
		| expression
		| expression ',' exprlist { $2->SetType(BAS_N_LIST);
			$$ = $2->Link($1, $3); }
		| nullexpr ',' exprlist { $2->SetType(BAS_N_LIST);
			$$ = $2->Link($1, $3); }
;

closelist:	/* Empty */ { $$ = NULL; }
		| expression {$$ = (new Node(BAS_S_CLOSE, "", 0))->Link($1); }
		| closelist ',' closelist { delete $2;
			$$ = $1->DownLink($3); }
;

datalist:	/* Empty */ { $$ = NULL; }
		| dataitem
		| dataitem ',' datalist { $2->SetType(BAS_N_LIST);
			$$ = $2->Link($1, $3); }
		| nullexpr ',' datalist { $2->SetType(BAS_N_LIST);
			$$ = $2->Link($1, $3); }
;

dataitem:	constant
		| '-' constant { $1->SetType(BAS_N_UMINUS);
			$$ = $1->Link($2); }
		| BAS_V_NAME
;

paramlist:	/* Empty */ { $$ = NULL; }
		| expressionx
		| expressionx ',' paramlist { $2->SetType(BAS_N_LIST);
			$$ = $2->Link($1, $3); }
		| nullexpr ',' paramlist { $2->SetType(BAS_N_LIST);
			$$ = $2->Link($1, $3); }
;

caseexprlist:	/* Empty */ { $$ = NULL; }
		| caseexpression
		| caseexpression ',' caseexprlist { $2->SetType(BAS_N_LIST);
			$$ = $2->Link($1, $3); }
;

caseexpression: expression
		| '=' expression { delete $1; $$=$2; }
		| '<' expression { $1->SetType(BAS_X_UNARYLT);
			$$ = $1->Link($2); }
		| BAS_X_LE expression { $1->SetType(BAS_X_UNARYLE);
			$$ = $1->Link($2); }
		| '>' expression { $1->SetType(BAS_X_UNARYGT);
			$$ = $1->Link($2); }
		| BAS_X_GE expression { $1->SetType(BAS_X_UNARYGE);
			$$ = $1->Link($2); }
		| BAS_X_NEQ expression { $1->SetType(BAS_X_UNARYNEQ);
			$$ = $1->Link($2); }
		| expression BAS_S_TO expression { $$ = $2->Link($1, $3); }
;

expressionx:	expression
		| expression BAS_S_BY tranmech { $$ = $2->Link($1, $3); }
;


nullexpr:	/* Empty */ {$$ = NULL; }
;

linelist:	lineno
		| lineno ',' linelist { $2->SetType(BAS_N_LIST);
			$$ = $2->Link($1, $3); }
;

lineno:		BAS_V_NAME { $1->SetType(BAS_V_USELABEL); $$ = $1; }
		| BAS_V_INTEGER { $1->SetType(BAS_V_USELABEL); $$ = $1; }
		| BAS_V_INT { $1->SetType(BAS_V_USELABEL); $$ = $1; }
		| BAS_S_OTHERWISE lineno { $$ = $1->Link($2); }
;

variablelist:	variable ',' variablelist { $2->SetType(BAS_N_LIST);
			$$ = $2->Link($1, $3); }
		| variable
;

readlist:	readlist ',' readlist { delete $2;
			$$ = $1->DownLink($3); }
		| variable {$$ = (new Node(BAS_S_READ, "", 0))->Link($1); }
;

variable:	variablex
		| variable BAS_X_STRREF variabley { $$ = $2->Link($1, $3); }
;

variablex:	BAS_V_NAME
		| BAS_V_NAME '(' paramlist ')' { if ($3 == NULL)
			{ $2->SetType(BAS_N_NULL);
			  $$ = $1->Link($2);
			} else
			{ $$ = $1->Link($3);
			  delete $2; }
			delete $4; }
;

variabley:	BAS_V_NAME { $1->SetType(BAS_N_STRUCTNAME); $$ = $1; }
		| BAS_V_NAME '(' paramlist ')' { $1->SetType(BAS_N_STRUCTNAME);
			if ($3 == NULL)
			{ $2->SetType(BAS_N_NULL);
			  $$ = $1->Link($2);
			} else
			{ $$ = $1->Link($3);
			  delete $2; }
			delete $4; }
;

constant:	BAS_V_INT
		| BAS_V_INTEGER
		| BAS_V_FLOAT
		| BAS_V_TEXTSTRING
;

function:	BAS_V_FUNCTION '(' paramlist ')' { $$ = $1->Link($3);
			delete $2; delete $4; }
		| vartypetwo '(' expression ',' vartypeone ')' {
			$1->SetType(BAS_N_TYPEFUN);
			$$ = $1->Link($3, $5);
			delete $2; delete $4; delete $6; }
;

optfor:		/* null */ { $$ = NULL }
		| BAS_S_FOR BAS_S_INPUT { $$ = $2; delete $1; }
		| BAS_S_FOR BAS_S_OUTPUT { $$ = $2; delete $1; }
;

optiontype:	'(' optionlist ')' { delete $1; delete $3; $$ = NULL; }
		| BAS_S_INTEGER BAS_S_BYTE { IntegerType = VARTYPE_BYTE;
			delete $1; delete $2; $$ = NULL; }
		| BAS_S_INTEGER BAS_S_WORD { IntegerType = VARTYPE_WORD;
			delete $1; delete $2; $$ = NULL; }
		| BAS_S_INTEGER BAS_S_LONG { IntegerType = VARTYPE_LONG;
			delete $1; delete $2; $$ = NULL; }
		| BAS_S_REAL BAS_S_SINGLE { RealType = VARTYPE_SINGLE;
			delete $1; delete $2; $$ = NULL; }
		| BAS_S_REAL BAS_S_DOUBLE { RealType = VARTYPE_DOUBLE;
			delete $1; delete $2; $$ = NULL; }
		| BAS_S_REAL BAS_S_GFLOAT { RealType = VARTYPE_GFLOAT;
			delete $1; delete $2; $$ = NULL; }
		| BAS_S_REAL BAS_S_HFLOAT { RealType = VARTYPE_HFLOAT;
			delete $1; delete $2; $$ = NULL; }
;

optionlist:	optiontype ',' optionlist { delete $2; $$ = NULL; }
		| optiontype { $$ = NULL; }
;

optvartype:	/* Null */ { $$ = NULL; }
		| vartype
;

vartype:	vartypeone
		| vartypetwo
;

vartypeone:	BAS_S_BYTE
		| BAS_S_DOUBLE
		| BAS_S_GFLOAT
		| BAS_S_HFLOAT
		| BAS_S_LONG
		| BAS_S_WORD
;

vartypetwo:	BAS_S_INTEGER
		| BAS_S_REAL
		| BAS_S_STRING
		| BAS_S_RFA
		| BAS_S_DECIMAL '(' exprlist ')' { delete $2;
			delete $4; delete $3; $$ = $1; }
;

fundeflist:	fundef
		| fundeflist ',' fundef { $2->SetType(BAS_N_LIST);
			$$ = $2->Link($1, $3); }
;

fundef:		BAS_V_NAME funby { $1->SetType(BAS_V_FUNCTION); $$ = $1; }
		| BAS_V_NAME funby '(' funparlist ')' { $1->SetType(BAS_V_FUNCTION);
			$$ = $1->Link($4);
			delete $3; delete $5; }
;

funby:		{ $$ = NULL; } /* This stuff Ignored for now */
		| BAS_S_BY tranmech { delete $1; delete $2; $$ = NULL; }
;

funparlist:	{ $$ = NULL; }
		| funpar
		| funparlist ',' funpar { $2->SetType(BAS_N_LIST);
			$$ = $2->Link($1, $3); }
; 

funpar:		funpara { $$ = $1; }
		| funpara BAS_S_BY tranmech { $$ = $2->Link($1, $3); }
;

funpara:	vartype fundim funsiz { $$ = $1->Link(NULL, $2, $3); }
		| vartype BAS_V_NAME fundim funsiz {
			$$ = $1->Link($4, $3, $2); }
		| BAS_V_NAME fundim funsiz {
			$$ = $1->Link(NULL, $2, $3); }
		| BAS_V_NAME BAS_V_NAME fundim funsiz { $1->SetType(BAS_N_VARTYPE);
			$$ = $1->Link($4, $3, $2); }
;

fundim:		/* Empty */ { $$ = NULL; }
		| BAS_S_DIM '(' fundimcom ')' { delete $2; delete $4;
			$$ = $1->Link($3); }
		| '(' fundimcom ')' { delete $1; delete $2;
			$$ = $2; }
;

fundimcom:	/* empty */ { $$ = NULL; }
		| expression { $$ = $1; }
		| ',' fundimcom { $1->SetType(BAS_N_LIST);
			$$ = $1->Link(NULL, $2); }
		| expression ',' fundimcom { $2->SetType(BAS_N_LIST);
			$$ = $2->Link($1, $3); }
;

funsiz:		/* empty */ { $$ = NULL; }
		| '=' expression { $$ = $2; delete $1; }
;

funequ:		/* Empty */ { $$ = NULL; }
		| '=' expression { $1->SetType(BAS_N_ASSIGN);
			$$ = $1->Link(NULL, $2); }
;

declarelist:	needvartype varnamelist { $$ = $1->Link($2); }
;

needvartype:	vartype
		| BAS_V_NAME { $1->SetType(BAS_N_VARTYPE); $$=$1; }
;

varnamelist:	varname
		| varname ',' varnamelist { $2->SetType(BAS_N_LIST);
			$$ = $2->Link($1, $3); }
;

varname:	BAS_V_NAME dimsz { $$ = $1->Link(NULL, NULL, $2); }
		| BAS_V_NAME dimdim dimsz { $$ = $1->Link($2, NULL, $3); }
;

maplist:	maplistone
		| maplist ',' maplistone { $2->SetType(BAS_N_LIST);
			$$ = $2->Link($1, $3); }
;

maplistone:	mapnamelist
		| needvartype mapnamelist { $$ = $1->Link($2); }
;

mapnamelist:	mapname
		| mapname ',' mapnamelist { $2->SetType(BAS_N_LIST);
			$$ = $2->Link($1, $3); }
;

mapname:	BAS_V_NAME dimdim dimsz { $$ = $1->Link($2, NULL, $3); }
		| BAS_V_NAME dimsz { $$ = $1->Link(NULL, NULL, $2); }
;

dimdeflist:	dimdef
		| dimdef ',' dimdeflist { $2->SetType(BAS_N_LIST);
			$$ = $2->Link($1, $3); }
;

dimdef:		vartype dimdim dimsz { $$ = $1->Link($2, NULL, $3); }
		| vartype BAS_V_NAME dimdim dimsz { $$ = $2->Link($3, $1, $4); }
		| BAS_V_NAME dimdim dimsz { $$ = $1->Link($2, NULL, $3); }
		| BAS_V_NAME BAS_V_NAME dimdim dimsz {
			$1->SetType(BAS_N_VARTYPE);
			$$ = $2->Link($3, $1, $4); }
;

dimdim:		'(' exprlist ')' { $$ = $2; delete $1; delete $3; }
;

dimsz:		/* Empty */ { $$ = NULL; }
		| '=' expression { $$ = $2; delete $1; }
;

getclause:	/* empty */	{ $$ = NULL; }
		| ',' BAS_S_RECORD expression getclause { 
			$1->SetType(BAS_N_LIST);
			$2->SetType(BAS_V_RMSRECORD);
			$$ = $1->Link($2->Link($3), $4); }
		| ',' BAS_S_REGARDLESS getclause { $1->SetType(BAS_N_LIST);
			$$ = $1->Link($2, $3); }
		| ',' BAS_S_KEY '#' expression getclause { $1->SetType(BAS_N_LIST);
			delete $3;
			$$ = $1->Link($2->Link($4), $5); }
		| ',' BAS_S_KEY '#' expression BAS_S_EQ expression getclause
			{ $1->SetType(BAS_N_LIST);
			delete $3;
			$$ = $1->Link($2->Link($4, $5, $6), $7); }
		| ',' BAS_S_KEY '#' expression BAS_S_GE expression getclause
			{ $1->SetType(BAS_N_LIST);
			delete $3;
			$$ = $1->Link($2->Link($4, $5, $6), $7); }
		| ',' BAS_S_KEY '#' expression BAS_S_GT expression getclause
			{ $1->SetType(BAS_N_LIST);
			delete $3;
			$$ = $1->Link($2->Link($4, $5, $6), $7); }
		| ',' BAS_S_RFA expression getclause { $1->SetType(BAS_N_LIST);
			$$ = $1->Link($2->Link($3), $4); }
		| ',' BAS_S_COUNT expression getclause { $1->SetType(BAS_N_LIST);
			$$ = $1->Link($2->Link($3), $4); }
		| ',' BAS_S_BLOCK expression getclause { $1->SetType(BAS_N_LIST);
			$$ = $1->Link($2->Link($3), $4); }
;

optprint:	optprint1 { $$ = $1; }
		| optprint1 hemisemi optprint { $$ = $2->Link($1, $3); }
;

optprint1:	/* Empty */	{ $$ = NULL; }
		| '#' expression { $$ = $1->Link($2); }
		| BAS_S_USING expression { $$ = $1->Link($2); }
		| '#' expression BAS_S_USING expression {
			$1->Link($2); $3->Link($4);
			$$ = (new Node(BAS_N_LIST, ";", 0))->
			Link($1, $3); }
		| BAS_S_RECORD expression { $1->SetType(BAS_N_RECORD);
			$$ = $1->Link($2); }
		| BAS_S_COUNT expression { $$ = $1->Link($2); }
		| expression { $$ = $1; }
;

optinput:	optinput1 { $$ = $1; }
		| optinput1 hemisemi optinput { $$ = $2->Link($1, $3); }
;

optinput1:	/* Empty */	{ $$ = NULL; }
		| '#' expression { $$ = $1->Link($2); }
		| expression { $$ = $1; }
;

hemisemi:	',' { $1->SetType(BAS_N_LIST); $$ = $1; }
		| ';' { $1->SetType(BAS_N_LIST); $$ = $1; }
;

tranmech:	BAS_S_VALUE
		| BAS_S_DESC
		| BAS_S_REF
;

openlist:	/* Empty */	{ $$ = NULL; }
		| openitem openlist { $$ = $1->DownLink($2); }
;

openitem:	',' BAS_S_ORGANIZATION orgclause { $$ = $2->Link($3);
			delete $1; }
		| ',' BAS_S_ALLOW allowtype { $$ = $2->Link($3);
			delete $1; }
		| ',' BAS_S_ACCESS allowtype { $$ = $2->Link($3);
			delete $1; }
		| ',' BAS_S_RECORDTYPE recordtype { $$ = $2->Link($3);
			delete $1; }
		| ',' BAS_S_RECORDSIZE expression { $$ = $2->Link($3);
			delete $1; }
		| ',' BAS_S_FILESIZE expression { $$ = $2->Link($3);
			delete $1; }
		| ',' BAS_S_WINDOWSIZE expression { $$ = $2->Link($3);
			delete $1; }
		| ',' BAS_S_TEMPORARY { $$ = $2; delete $1; }
		| ',' BAS_S_CONTIGUOUS { $$ = $2; delete $1; }
		| ',' BAS_S_MAP variable { $$ = $2->Link($3);
			delete $1; }
		| ',' BAS_S_CONNECT expression { $$ = $2->Link($3);
			delete $1; }
		| ',' BAS_S_BUFFER expression { $$ = $2->Link($3);
			delete $1; }
		| ',' BAS_S_DEFAULTNAME expression { $$ = $2->Link($3);
			delete $1; }
		| ',' BAS_S_EXTENDSIZE expression { $$ = $2->Link($3);
			delete $1; }
		| ',' BAS_S_BLOCKSIZE expression { $$ = $2->Link($3);
			delete $1; }
		| ',' BAS_S_NOREWIND { $$ = $2; delete $1; }
		| ',' BAS_S_NOSPAN { $$ = $2; delete $1; }
		| ',' BAS_S_SPAN { $$ = $2; delete $1; }
		| ',' BAS_S_BUCKETSIZE expression { $$ = $2->Link($3);
			delete $1; }
		| ',' BAS_S_PRIMARY BAS_S_KEY prenexprlist dupcha { delete $1;
			delete $3; $$ = $2->Link($4); }
		| ',' BAS_S_PRIMARY prenexprlist dupcha { delete $1;
			$$ = $2->Link($3); }
		| ',' BAS_S_ALTERNATE BAS_S_KEY prenexprlist dupcha { delete $1;
			delete $3; $$ = $2->Link($4); }
		| ',' BAS_S_MODE expression { delete $1;
			$$ = $2->Link($3); }
;

orgclause:	BAS_S_INDEXED orgtype {$$ = $1->Link($2); }
		| BAS_S_RELATIVE orgtype {$$ = $1->Link($2); }
		| BAS_S_VIRTUAL orgtype {$$ = $1->Link($2); }
		| BAS_S_SEQUENTIAL orgtype {$$ = $1->Link($2); }
		| BAS_S_UNDEFINED orgtype {$$ = $1->Link($2); }
;

orgtype:	/* Empty */	{ $$ = NULL; }
		| BAS_S_STREAM
		| BAS_S_VARIABLE
		| BAS_S_FIXED
;

allowtype:	BAS_S_NONE
		| BAS_S_READ
		| BAS_S_WRITE
		| BAS_S_MODIFY
		| BAS_S_APPEND
		| BAS_S_SCRATCH
;

recordtype:	BAS_S_LIST
		| BAS_S_FORTRAN
		| BAS_S_NONE
		| BAS_S_ANY
;

dupcha:		/* Empty */ { $$ = NULL; }
		| BAS_S_NODUPLICATES dupcha { $$ = $1->Link($2); }
		| BAS_S_DUPLICATES dupcha { $$ = $1->Link($2); }
		| BAS_S_CHANGES dupcha { $$ = $1->Link($2); }
		| BAS_S_NOCHANGES dupcha { $$ = $1->Link($2); }
;

fieldlist:	/* Empty */ { $$ = NULL; }
		| fielditem
		| fielditem ',' fieldlist { $2->SetType(BAS_N_LIST);
			$$ = $2->Link($1, $3); }
;

fielditem:	expression BAS_S_AS variablex { $$ = $2->Link($1, $3); }
;
%%

/*
 * Display error messages
 */
int yyerror(char *s)
{
	cerr << "Parse error: " << s << " near line " << xline << endl;
	if (include_stack_pointer > 0)
	{
		cout << " in included file " <<
			include_name[include_stack_pointer - 1] << endl;
	}
	return 0;
}

