/*
 * Fucntions to process a print using format field
 */

static void UsingStringAttach(char* Output, const char* Value,
	int Size, int Position);



int UsingString(const char* Format, const char* Value, char* Output)
{
	int OutLength = 0;	/* Current length of output file */
	int FormatPtr = 0;	/* Pointer into format string */
	int Size = 0;		/* Size available to output string */
	int Position;		/* 0=Left, 1=Right, 2=Center */
	char FormatChar;	/* Format character to use */

	/*
	 * Scan over characters that won't start the format
	 */
	while (Format[FormatPtr] != '\0')
	{
		switch (Format[FormatPtr])
		{
		case '/':
			FormatPtr++;
			Size = 2;
			Output[OutputLength + 1] = '\0';

			while ((Format[FormatPtr] != '\0') &&
				(Format[FormatPtr] != '/'))
			{
				Size++;
				FormatPtr++;
			}
			UsingStringAttach(Output, Value, Size, 0);
			OutputLength = strlen(Output);
			FormatPtr++;

			break;

		case '\'':
			FormatPtr++;
			Size = 1;
			Output[OutputLength + 1] = '\0';
			FormatChar = Format[FormatPtr];

			switch 
			{
			case 'c':
			case 'C':
				Position = 1;
				break;

			case 'l':
			case 'L':
				Position = 0;
				break;

			case 'r':
			case 'R':
				Position = 2;
				break;

			default:
				FormatChar = 0;
				break;
			}

			while (Format[FormatPtr] == FormatChar)
			{
				Size++;
				FormatPtr++;
			}
			UsingStringAttach(Output, Value, Size, Position);
			OutputLength = strlen(Output);
			break;

		case '!':
			FormatPtr++;
			if (Value[0] != '\0')
			{
				Output[OutputLength++] = Value[0];
			}
			else
			{
				Output[OutputLength++] = ' ';
			}
			break;

		default:
			Output[OutLength++] = Format[FormatPtr++];
			break;
		}
	}
}

static void UsingStringAttach(char* Output, const char* Value,
	int Size, int Position)
{
	int NeedSpaces;		/* Spaces needed to get proper length */
	int OutputPos = strlen(Output);

	NeedSpaces = Size - strlen(Value);
	if (NeedSpaces < 0)
	{
		NeedSpaces = 0;
	}
}

